function vexpower_getCpsCurrent(change)
	local new = 0

	if change ~= nil then
		new = vexpower.currentcps+change
	else
		new = vexpower_getCPs(true)
	end

	return new
end

function vexpower_getSpecTypeAuraID()
	local returnvalue = 0
	if vexpower.class == "SHAMAN" and vexpower.specType == 263 then 		-- Enhancer
		returnvalue = 53817
	elseif vexpower.class == "HUNTER" and vexpower.specType == 254 then		-- Marksman
		returnvalue = 82925
	elseif vexpower.class == "HUNTER" and vexpower.specType == 253 then		-- Beast Master
		returnvalue = 19615
	elseif vexpower.class == "WARRIOR" and vexpower.specType == 71 then		-- Arms
		returnvalue = 125831
	elseif vexpower.class == "PRIEST" and vexpower.specType == 256 then		-- Discipline
		returnvalue = 81661
	elseif vexpower.class == "MAGE" and vexpower.specType == 62 then		-- Arcane
		returnvalue = 36032
	end
	
	return returnvalue
end

function vexpower_getDebuffTime(type)
	local returnvalue = ""
	local auraid = vexpower_getSpecTypeAuraID()
	
	if auraid ~= 0 then
		local buffname = select(1, GetSpellInfo(auraid))
		if UnitDebuff("player", buffname) ~= nil then
			if type == "total" then
					returnvalue = tostring(select(6, UnitDebuff("player", buffname)))
			elseif type == "left" then
				local expire = select(7, UnitDebuff("player", buffname))
				local left = expire-GetTime()
				if left >= 10 then
					left = string.sub(left, 1,4)
					returnvalue = tostring(left)
				elseif left < 10 and left > 0 then
					left = string.sub(left, 1,3)
					returnvalue = tostring(left)
				end
			end
		end
	end
	
	return returnvalue
end

function vexpower_getBuffTime(type)
	local returnvalue = ""
	local auraid = vexpower_getSpecTypeAuraID()
	
	if auraid ~= 0 then
		local buffname = select(1, GetSpellInfo(auraid))
		if UnitBuff("player", buffname) ~= nil then
			if type == "total" then
					returnvalue = tostring(select(6, UnitBuff("player", buffname)))
			elseif type == "left" then
				local expire = select(7, UnitBuff("player", buffname))
				local left = expire-GetTime()
				if left >= 10 then
					left = string.sub(left, 1,4)
					returnvalue = tostring(left)
				elseif left < 10 and left > 0 then
					left = string.sub(left, 1,3)
					returnvalue = tostring(left)
				end
			end
		end
	end
	
	return returnvalue
end

function vexpower_getCpsDebuffCurrent()
	local count = 0
	local continue = true
	local i = 1
	local auraid = vexpower_getSpecTypeAuraID()
	
	if auraid ~= 0 then
		while continue do
			if UnitDebuff("player", i, nil, "PLAYER") == nil then
				continue = false
			elseif select(11, UnitDebuff("player", i)) == auraid then
				count = select(4, UnitDebuff("player", i))
				continue = false
			end
			i = i + 1
		end
	end	
	return count
end

function vexpower_getCpsBuffCurrent()
	local count = 0
	local continue = true
	local i = 1
	local auraid = vexpower_getSpecTypeAuraID()
	
	if auraid ~= 0 then
		while continue do
			if UnitBuff("player", i, nil, "PLAYER") == nil then
				continue = false
			elseif select(11, UnitBuff("player", i)) == auraid then
				count = select(4, UnitBuff("player", i))
				continue = false
			end
			i = i + 1
		end
	end
	
	-- Marksman Override for "Fire!"
	i = 1
	continue = true
	if vexpower.class == "HUNTER" and vexpower.specType == 254 then
		while continue do
			if UnitBuff("player", i, nil, "PLAYER") == nil then
				continue = false
			elseif select(11, UnitBuff("player", i)) == 82926 then
				count = vexpower.maxcps
				continue = false
			end
			i = i + 1
		end
	end
	
	return count
end

function vexpower_getCPs(current)
	local returnvalue = 0
	
	if vexpower.class == "DRUID" or vexpower.class == "ROGUE" then
		if current then
			returnvalue = GetComboPoints("player")
		else
			returnvalue = 5	
		end
	elseif vexpower.class == "PALADIN" then
		if current then
			returnvalue = UnitPower("player", 9)
		else
			returnvalue = UnitPowerMax("player", 9)
		end
	elseif vexpower.class == "MONK" then
		if current then
			returnvalue = UnitPower("player", 12) 
		else
			returnvalue = UnitPowerMax("player", 12)
		end
	elseif vexpower.class == "PRIEST" then
		if vexpower.specType == 258 then		-- Shadow
			if current then
				returnvalue = UnitPower("player", 13) 
			else
				returnvalue = UnitPowerMax("player", 13) 
			end
		elseif vexpower.specType == 256 then 	-- Discipline
			if current then
				returnvalue = vexpower_getCpsBuffCurrent()
			else
				returnvalue = 5
			end
		end
	elseif vexpower.class == "WARLOCK" then
		if vexpower.specType == 265 then		-- Affliction
			if current then
				returnvalue = UnitPower("player", 7)
			else
				returnvalue = UnitPowerMax("player", 7)
			end
		elseif vexpower.specType == 266 then	-- Demonology
			if current then
				returnvalue = 0
			else
				returnvalue = 1
			end
		elseif vexpower.specType == 267 then	-- Destruction
			if current then
				returnvalue = UnitPower("player", 14)
			else
				returnvalue = UnitPowerMax("player", 14)
			end
		end
	elseif vexpower.class == "WARRIOR" then
		if vexpower.specType == 71 then			-- Arms
			if current then
				returnvalue = vexpower_getCpsBuffCurrent()
			else
				returnvalue = 5
			end
		end
	elseif vexpower.class == "SHAMAN" then
		if vexpower.specType == 263 then 		-- Enhancer
			if current then
				returnvalue = vexpower_getCpsBuffCurrent()
			else
				returnvalue = 5
			end
		end
	elseif vexpower.class == "HUNTER" then
		if vexpower.specType == 254 then 		-- Marksman
			if current then
				returnvalue = vexpower_getCpsBuffCurrent()
			else
				returnvalue = 3
			end
		elseif vexpower.specType == 253 then 	-- Beast Master
			if current then
				returnvalue = vexpower_getCpsBuffCurrent()
			else
				returnvalue = 5
			end
		end
	elseif vexpower.class == "MAGE" then
		if vexpower.specType == 62 then 		-- Arcane
			if current then
				returnvalue = vexpower_getCpsDebuffCurrent()
			else
				returnvalue = 6
			end
		end
	end
	
	if not(current) and returnvalue > 6 then
		returnvalue = 6
	end
	
	return returnvalue
end

function vexpower_setCpsCurrent(change)
	local new = vexpower_getCpsCurrent(change)
	
	if change ~= nil then new = vexpower.currentcps+change end
	
	if new ~= vexpower.currentcps then
		vexpower.currentcps_prev = vexpower.currentcps
		vexpower.currentcps = new
	end
end

function vexpower_getCpsMax()
	return vexpower_getCPs(false)
end

function vexpower_setCpsMax()
	vexpower.maxcps = vexpower_getCpsMax()
end

function vexpower_changeCps(change)
	vexpower_setCpsCurrent(change)
	if vexpower.currentcps > vexpower.currentcps_prev then
		--CPs built
		for i=1, vexpower.currentcps do
			vexpower_setCpsBarsBGColor(i, true)
			if vexpower.cpsbars_anigrps[i]:IsPlaying() then
				vexpower.cpsbars_anigrps[i]:Stop()
			end
			vexpower.cpsbars[i]:Show()
		end
	else
		--CPs used
		for i=1, vexpower.maxcps do
			vexpower_setCpsBarsBGColor(i, true)
		end
		
		local cpsLost = vexpower.currentcps_prev-vexpower.currentcps
		
		for i=1, cpsLost do
			local bar = vexpower.currentcps_prev+1-i
			vexpower_setCpsBarsBGColor(bar, false)
			if vexpower_parameters["frame"]["combo"]["fadeout"] then
				vexpower.cpsbars_anigrps[bar]:Play()
			else
				vexpower.cpsbars[bar]:Hide()
			end
		end
	end
	vexpower_soundCheck()
end

function vexpower_setCpsBarsBGColor(cp, standard)
	if vexpower.cpsbars[cp] ~=nil then
		local color = tostring(cp)
		if vexpower_parameters["frame"]["combo"]["bg"]["allowchange"] and vexpower.currentcps >= tonumber(vexpower_parameters["frame"]["combo"]["bg"]["cpchange"]) then
			if (vexpower_parameters["frame"]["combo"]["bg"]["cpchangeonly"] and cp <= tonumber(vexpower_parameters["frame"]["combo"]["bg"]["cpchange"])) or
						not(vexpower_parameters["frame"]["combo"]["bg"]["cpchangeonly"])  				then color = "change"
			end
		end
		if not(standard) then color = "used" end
		vexpower.cpsbars[cp]:SetBackdropColor(	vexpower_parameters["frame"]["combo"]["bg"]["color"][color]["r"],
												vexpower_parameters["frame"]["combo"]["bg"]["color"][color]["g"],
												vexpower_parameters["frame"]["combo"]["bg"]["color"][color]["b"],
												vexpower_parameters["frame"]["combo"]["bg"]["color"][color]["a"])
	end
end

function vexpower_setCpsBars()
	if not(vexpower.testmode) then
		if vexpower.cpsbars ~= nil then
			for i=1, #vexpower.cpsbars do
				if vexpower.cpsbars[i] ~= nil then vexpower.cpsbars[i]:Hide() end
			end
		end
	end
	
	local offset_total = vexpower_parameters["frame"]["combo"]["measure"]["offset"]*2
	local gap_total = (vexpower.maxcps-1)*vexpower_parameters["frame"]["combo"]["measure"]["gap"]
	
	local width = 0
	if vexpower.maxcps == 0 then width = (vexpower_parameters["frame"]["energy"]["size"]["width"] - gap_total - offset_total)
	else 						 width = (vexpower_parameters["frame"]["energy"]["size"]["width"] - gap_total - offset_total)/vexpower.maxcps end

	local start = {}
	start[1] = vexpower_parameters["frame"]["combo"]["measure"]["offset"]
	if vexpower.maxcps > 1 then
		for i=2, vexpower.maxcps do
			start[i] = start[i-1]+width+vexpower_parameters["frame"]["combo"]["measure"]["gap"]
		end
	end
	
	local animationduration = 0.3
	
	--Setup CPs
	for i=1, vexpower.maxcps do
		
		if not(vexpower.testmode) then
			vexpower.cpsbars[i] = CreateFrame("Frame", nil, vexpower_cpsbar)
		end
		vexpower.cpsbars[i]:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Buttons\\WHITE8X8", tile=false,
											edgeSize=vexpower_parameters["frame"]["combo"]["border"]["size"]})
		vexpower_setCpsBarsBGColor(i, true)
		vexpower.cpsbars[i]:SetBackdropBorderColor(vexpower_parameters["frame"]["combo"]["border"]["color"]["r"],
														vexpower_parameters["frame"]["combo"]["border"]["color"]["g"],
														vexpower_parameters["frame"]["combo"]["border"]["color"]["b"],
														vexpower_parameters["frame"]["combo"]["border"]["color"]["a"])
		vexpower.cpsbars[i]:SetHeight(vexpower_parameters["frame"]["combo"]["measure"]["height"])
		
		if not(vexpower.testmode) then
			if vexpower.currentcps > 0 then vexpower.cpsbars[i]:Show()
			else vexpower.cpsbars[i]:Hide() end
		end
		vexpower.cpsbars[i]:SetWidth(width)
		vexpower.cpsbars[i]:ClearAllPoints()
		vexpower.cpsbars[i]:SetPoint("TOPLEFT", vexpower_energybarbg, "TOPLEFT", start[i], vexpower_parameters["frame"]["combo"]["measure"]["y"])
		
		vexpower.cpsbars_anigrps[i] = vexpower.cpsbars[i]:CreateAnimationGroup("vexpower.cpsbars_anigrps["..i.."]")
		vexpower.cpsbars_anigrps[i]:SetLooping("NONE")
		vexpower.cpsbars_anigrps[i]:SetScript("OnPlay", function () vexpower.cpsbars[i]:Show() end)
		vexpower.cpsbars_anigrps[i]:SetScript("OnFinished", function () vexpower.cpsbars[i]:Hide() end)
		vexpower.cpsbars_anis[i] = vexpower.cpsbars_anigrps[i]:CreateAnimation("Alpha")
		vexpower.cpsbars_anis[i]:SetDuration(animationduration)
		vexpower.cpsbars_anis[i]:SetOrder(1)
		vexpower.cpsbars_anis[i]:SetChange(-1)
		
	end
end

function vexpower_setcpsbar()
	vexpower_cpsbar:SetWidth(1)
	vexpower_cpsbar:SetHeight(1)
	vexpower_cpsbar:ClearAllPoints()
	vexpower_cpsbar:SetPoint("TOPLEFT", vexpower_MainFrame, "TOPLEFT", 0, 0)
end

function vexpower_ShowCPs()
	for i=1, #vexpower.cpsbars do
		if vexpower.cpsbars[i] ~=nil then
			if i <= vexpower.currentcps then
				vexpower.cpsbars[i]:Show()
			else
				vexpower.cpsbars[i]:Hide()
			end
		end
	end
end

function vexpower_soundCheck()
	local x = vexpower_parameters["sound"]["x"]
	if vexpower.currentcps_prev < x and vexpower.currentcps >= x and vexpower_parameters["sound"]["activate"] then
		PlaySoundFile(vexpower.LSM:Fetch("sound", vexpower_parameters["sound"]["file"]), vexpower_parameters["sound"]["channel"])
	end
end