

function vexpower_setInVehicle(player, entered)
	if player == "player" then
		if entered then
			vexpower.inVehicle = true
		else
			vexpower.inVehicle = false
		end
	end
end

function vexpower_setSpec()
	vexpower.spec = GetActiveSpecGroup(false, false)
	
	local specType = 0
	if GetSpecialization() ~= nil then
		if GetSpecializationInfo(GetSpecialization()) ~= nil then
			specType = select(1, GetSpecializationInfo(GetSpecialization()))
		end
	end
	vexpower.specType = specType
end

function vexpower_setClass()
	vexpower.class = select(2, UnitClass("player"))
end

function vexpower_startInfightTimer()
	if vexpower.infightTimer_ani[1]:IsPlaying() then
		vexpower.infightTimer_ani[1]:Stop()
	end
	vexpower.infightTimer_ani[1]:Play()
end

function vexpower_PowerTypeColorHex(powertype)
	return vexpower_dec2hex(PowerBarColor[powertype]["r"],PowerBarColor[powertype]["g"],PowerBarColor[powertype]["b"])
end

function vexpower_ClassColorHex(class)
	return vexpower_dec2hex( RAID_CLASS_COLORS[class]["r"], RAID_CLASS_COLORS[class]["g"], RAID_CLASS_COLORS[class]["b"])
end

function vexpower_dec2hex(r,g,b)
	if r == nil then r = 0 end
	if g == nil then g = 0 end
	if b == nil then b = 0 end
    return string.format("%02x%02x%02x", r*250, g*250, b*250)
end

function vexpower_setBlizzFrames()	
	if vexpower_parameters["blizzhide"]["holypower"] then
		PaladinPowerBar.Show = function () end
		PaladinPowerBar:Hide()
		PaladinPowerBar:UnregisterAllEvents()
	end	
	
	if vexpower_parameters["blizzhide"]["lockShards"] then
		ShardBarFrame.Show = function () end
		ShardBarFrame:Hide()
		ShardBarFrame:UnregisterAllEvents()
	end
	
	if vexpower_parameters["blizzhide"]["cps"] then
		ComboFrame.Show = function () end
		ComboFrame:Hide()
		ComboFrame:UnregisterAllEvents()
	end
end

function vexpower_setInfightTimer()
	vexpower.infightTimer_ani[1] = vexpower_infightTimer:CreateAnimationGroup("vexpower.infightTimer_aniGrp")
	vexpower.infightTimer_ani[1]:SetLooping("NONE")
	vexpower.infightTimer_ani[1]:SetScript("OnFinished", function ()
			vexpower.infight = false
			vexpower_showHandler()
			vexpower_setEnergybarColor()
		end)
	vexpower.infightTimer_ani[2] = vexpower.infightTimer_ani[1]:CreateAnimation("Alpha")
	vexpower.infightTimer_ani[2]:SetDuration(vexpower_parameters["frame"]["infightdelay"])
	vexpower.infightTimer_ani[2]:SetOrder(1)
	vexpower.infightTimer_ani[2]:SetChange(0)
end