
function vexpower_changeEnergyText()
	vexpower_energytext_left:SetText(vexpower_parseTagInfo(vexpower_parameters["frame"]["energy"]["text"]["left"]["text"]))
	vexpower_energytext_right:SetText(vexpower_parseTagInfo(vexpower_parameters["frame"]["energy"]["text"]["right"]["text"]))
end

function vexpower_parseTagInfo(text)
	local percenergy = 0
	if vexpower.maxenergy ~= 0 then
		percenergy = (vexpower.currentenergy/vexpower.maxenergy)*100
	end
	local missingEnergy = vexpower.maxenergy-vexpower.currentenergy
	local missingCPs = vexpower.maxcps - vexpower.currentcps
	
	local PowerAltCurrent = ""
	local PowerAltMax = ""
	if vexpower.class == "WARLOCK" and vexpower.specType == 267 then
		PowerAltCurrent = UnitPower("player", 14, true)
		if PowerAltCurrent >= 20 then
			PowerAltCurrent = PowerAltCurrent - 20
		elseif PowerAltCurrent >= 10 then
			PowerAltCurrent = PowerAltCurrent - 10
		end
		PowerAltMax = 10
	elseif vexpower.class == "WARLOCK" and vexpower.specType == 266 then
		PowerAltCurrent = UnitPower("player", 15)
		PowerAltMax = UnitPowerMax("player", 15)
	end
	
	text = string.gsub(text, "%[PowerCurrent%]", vexpower.currentenergy)
	text = string.gsub(text, "%[PowerCurrentSmart%]", vexpower_GetEnergyShort(vexpower.currentenergy, true, vexpower.maxenergy))
	text = string.gsub(text, "%[PowerCurrentShort%]", vexpower_GetEnergyShort(vexpower.currentenergy, false, vexpower.maxenergy))
	
	text = string.gsub(text, "%[PowerMax%]", vexpower.maxenergy)
	text = string.gsub(text, "%[PowerMaxSmart%]", vexpower_GetEnergyShort(vexpower.maxenergy, true, vexpower.maxenergy))
	text = string.gsub(text, "%[PowerMaxShort%]", vexpower_GetEnergyShort(vexpower.maxenergy, false, vexpower.maxenergy))
	
	text = string.gsub(text, "%[PowerMissing%]", missingEnergy)
	text = string.gsub(text, "%[PowerMissingSmart%]", vexpower_GetEnergyShort(missingEnergy, true, vexpower.maxenergy))
	text = string.gsub(text, "%[PowerMissingShort%]", vexpower_GetEnergyShort(missingEnergy, false, vexpower.maxenergy))
	
	text = string.gsub(text, "%[PowerPerc%]", vexpower_GetEnergyShort(percenergy, false, 100))
	text = string.gsub(text, "%[PowerPercSmart%]", vexpower_GetEnergyShort(percenergy, true, 100))
	
	if vexpower.class == "MAGE" and vexpower.specType == 62 then
		text = string.gsub(text, "%[BuffDurationTotal%]", vexpower_getDebuffTime("total"))
		text = string.gsub(text, "%[BuffDurationLeft%]", vexpower_getDebuffTime("left"))
	else
		text = string.gsub(text, "%[BuffDurationTotal%]", vexpower_getBuffTime("total"))
		text = string.gsub(text, "%[BuffDurationLeft%]", vexpower_getBuffTime("left"))
	end
	text = string.gsub(text, "%[PowerAltCurrent%]", PowerAltCurrent)
	text = string.gsub(text, "%[PowerAltMax%]", PowerAltMax)
	
	text = string.gsub(text, "%[CPsCurrent%]", tostring(vexpower.currentcps))
	text = string.gsub(text, "%[CPsMax%]", tostring(vexpower.maxcps))
	text = string.gsub(text, "%[CPsMissing%]", tostring(missingCPs))
	return text
end

function vexpower_GetEnergyShort(amount, smart, maximum)

	local returnvalue = ""
	if maximum < 1000 then
		amount = amount*1000
	end
	if smart then
		amount = tonumber(amount)/100
		amount = vexpower_CeilNumber(tonumber(amount))
		amount = tostring(amount / 10)
		if string.find(amount, "%.") == nil then
			amount = amount..".0"
		end
		returnvalue = amount
	else
		amount = tonumber(amount)/1000
		amount = vexpower_CeilNumber(tonumber(amount))
		returnvalue = tostring(amount)
	end
	return returnvalue
end

function vexpower_CeilNumber(amount)
	local returnvalue = ""
	amount = tostring(amount)
	if string.find(amount, "%.") ~= nil then
		local amount_l = string.gsub(amount, "%.%d+$", "")
		local amount_r = string.gsub(amount, "^%d+%.", "0.")
		amount_l = tonumber(amount_l)
		amount_r = tonumber(amount_r)
		if amount_r >= 0.5 then
			amount_l = amount_l+1
		end
		returnvalue = amount_l
	else
		returnvalue = tonumber(amount)
	end
	return returnvalue
end

function vexpower_setEnergyTextbar()
	vexpower_energyTextbar:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Buttons\\WHITE8X8", tile=false, edgeFile="Interface\\Buttons\\WHITE8X8", edgeSize=1})
	vexpower_energyTextbar:SetBackdropColor(0, 0, 0, 0)
	vexpower_energyTextbar:SetBackdropBorderColor(1,1,1,0)
	vexpower_energyTextbar:SetWidth(vexpower.maxwidth)
	vexpower_energyTextbar:SetHeight(vexpower_parameters["frame"]["energy"]["size"]["height"]-(vexpower_parameters["frame"]["energy"]["border"]["size"]*2))
	vexpower_energyTextbar:ClearAllPoints()
	vexpower_energyTextbar:SetPoint("TOPLEFT", vexpower_energybarbg, "TOPLEFT",
						vexpower_parameters["frame"]["energy"]["border"]["size"],
						-vexpower_parameters["frame"]["energy"]["border"]["size"])
end

function vexpower_setFontStrings()
	-- FontString 1
	vexpower_energytext_left:ClearAllPoints()
	vexpower_energytext_left:SetPoint("TOPLEFT", vexpower_energyTextbar, "TOPLEFT" , vexpower_parameters["frame"]["energy"]["text"]["left"]["x"], vexpower_parameters["frame"]["energy"]["text"]["left"]["y"])
	vexpower_energytext_left:SetTextColor(vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["r"],
											vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["g"],
											vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["b"],
											vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["a"])
	vexpower_energytext_left:SetFont(vexpower.LSM:Fetch("font", vexpower_parameters["frame"]["energy"]["text"]["left"]["font"]),
									vexpower_parameters["frame"]["energy"]["text"]["left"]["size"],
									vexpower_parameters["frame"]["energy"]["text"]["left"]["effect"])	
	vexpower_energytext_left:SetWidth(vexpower_parameters["frame"]["energy"]["text"]["left"]["width"])	
	vexpower_energytext_left:SetJustifyH(vexpower_parameters["frame"]["energy"]["text"]["left"]["align"])
	if vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["allow"] then	
		vexpower_energytext_left:SetShadowColor(vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["color"]["r"],
											vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["color"]["g"],
											vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["color"]["b"],
											vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["color"]["a"])
		vexpower_energytext_left:SetShadowOffset(vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["offset"]["x"],
											vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["offset"]["y"])
	else
		vexpower_energytext_left:SetShadowColor(0, 0, 0, 0)
		vexpower_energytext_left:SetShadowOffset(0, 0)
	end
	
	
	-- FontString 2
	vexpower_energytext_right:ClearAllPoints()
	vexpower_energytext_right:SetPoint("TOPRIGHT", vexpower_energyTextbar, "TOPRIGHT" , vexpower_parameters["frame"]["energy"]["text"]["right"]["x"], vexpower_parameters["frame"]["energy"]["text"]["right"]["y"])
	vexpower_energytext_right:SetTextColor(vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["r"],
											vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["g"],
											vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["b"],
											vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["a"])
	vexpower_energytext_right:SetFont(vexpower.LSM:Fetch("font", vexpower_parameters["frame"]["energy"]["text"]["right"]["font"]),
									vexpower_parameters["frame"]["energy"]["text"]["right"]["size"],
									vexpower_parameters["frame"]["energy"]["text"]["right"]["effect"])	
	vexpower_energytext_right:SetWidth(vexpower_parameters["frame"]["energy"]["text"]["right"]["width"])	
	vexpower_energytext_right:SetJustifyH(vexpower_parameters["frame"]["energy"]["text"]["right"]["align"])
	
	if vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["allow"] then	
		vexpower_energytext_right:SetShadowColor(vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["color"]["r"],
											vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["color"]["g"],
											vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["color"]["b"],
											vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["color"]["a"])
		vexpower_energytext_right:SetShadowOffset(vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["offset"]["x"],
											vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["offset"]["y"])
	else
		vexpower_energytext_right:SetShadowColor(0, 0, 0, 0)
		vexpower_energytext_right:SetShadowOffset(0, 0)
	end
	
end