vexpower.new_marker_location = ""
vexpower.new_marker_spec = ""
vexpower.new_marker_powertype = {
	["FOCUS"] = true,
	["MANA"] = true,
	["RUNIC_POWER"] = true,
	["ENERGY"] = true,
	["RAGE"] = true,
	}
vexpower.marker_created = " "
vexpower.marker_deleted = " "

function vexpower.panel_markers()		
	return {
		type = "group",
		order= 5,
		args = {
			grpex = {
				name = "Examples",
				order=1, type = "group", dialogInline = true,
				args = {
					infopic={name = "", type="description", order=1, image="Interface\\AddOns\\vexpower\\images\\options_markers.tga",
						imageWidth=512, imageHeight=64},	
					info1={name = "Examples for markers are in the red circles\n", type="description", order=2,},	
					info2={name = "Markers are marks at specific places on your energybar. They can be placed at absolute positions and at relative positions.", type="description", order=3, fontSize="medium"},	
					info3={name = "'50' will be placed on the energybar that represents 50 of your mana/energy/etc", type="description", order=4, fontSize="medium"},	
					info4={name = "'50%' will be placed on the energybar that represents 50% of your mana/energy/etc", type="description", order=5, fontSize="medium"},	
					info5={name = "You can also create specific markers that shall only be shown with specific powertypes. That way druids can set markers for specific forms. By setting a marker for energy only the marker will only be shown when they are in their cat-form.", type="description", order=8, fontSize="medium"},
					space1={name= " ", type="description", order=1000},
					},
				},
			frame_space = {name =" ", type = "description", order=2},
			
			
			grpadd = {
				name = "Add/Overwrite marker",
				order=10, type ="group", dialogInline = true,
				args = {
					marker_new = {
						name = "Location",
						desc = "Enter a location where to put the new marker",
						order=1, type = "input", multiline = false,
						validate = function (info, val)
							if vexpower_panel_markercheck(val) then return true
							else print("ERROR - "..val.." is not a valid position") return false end
							end,
						set = function(info,val) vexpower.new_marker_location=val end,
						get = function() return vexpower.new_marker_location end,
						},
					marker_new_spec = {
						name = "Visible for",
						order=2, type = "select", style = "dropdown",
						values = {[""]="Both Specs", ["a"]="Primary Spec", ["b"]="Secondary Spec"},
						set = function(self,key) vexpower.new_marker_spec = key end,
						get = function() return vexpower.new_marker_spec end,
						},
					powertypes = {
						name = "Visible with the following powertypes",
						order=3, type ="group", dialogInline = true,
						args = {
							marker_new_powertype_rage = {
								name = "Rage (R)",
								order=1, type = "toggle", width="half",
								set = function(self,key) vexpower.new_marker_powertype["RAGE"] = key vexpower_initialize(true) end,
								get = function() return vexpower.new_marker_powertype["RAGE"] end,
								},
							marker_new_powertype_mana = {
								name = "Mana (M)",
								order=2, type = "toggle", width="half",
								set = function(self,key) vexpower.new_marker_powertype["MANA"] = key vexpower_initialize(true) end,
								get = function() return vexpower.new_marker_powertype["MANA"] end,
								},
							marker_new_powertype_focus = {
								name = "Focus (F)",
								order=3, type = "toggle", width="half",
								set = function(self,key) vexpower.new_marker_powertype["FOCUS"] = key vexpower_initialize(true) end,
								get = function() return vexpower.new_marker_powertype["FOCUS"] end,
								},
							marker_new_powertype_energy = {
								name = "Energy (E)",
								order=4, type = "toggle",
								set = function(self,key) vexpower.new_marker_powertype["ENERGY"] = key vexpower_initialize(true) end,
								get = function() return vexpower.new_marker_powertype["ENERGY"] end,
								},
							marker_new_powertype_rp = {
								name = "Runic Power (RP)",
								order=5, type = "toggle",
								set = function(self,key) vexpower.new_marker_powertype["RUNIC_POWER"] = key vexpower_initialize(true) end,
								get = function() return vexpower.new_marker_powertype["RUNIC_POWER"] end,
								},
							},
						},
					marker_new_add = {
						name = "add",
						order=4, type = "execute",
						func = function(info,val) vexpower_panel_addmarker() vexpower_initialize(true) end,
						},
					marker_new_info = {name = vexpower.marker_created, type = "description", order=20},
					},
				},
			grpadddelete_space = {name =" ", type = "description", order=11},
			
			grpdelete = {
				name = "Delete marker",
				order=20, type ="group", dialogInline = true,
				args = {
					marker_delete = {
						name = "Both specs",
						order=1, type = "select", style = "dropdown",
						desc = "Delete an existing marker",
						values = vexpower_panel_getMarker("both"),
						set = function(self,key) vexpower_panel_deletemarker(key, "") vexpower_initialize(true) end,
						get = function() return "" end,
						},
					marker_delete_a = {
						name = "Primary Spec",
						order=2, type = "select", style = "dropdown",
						desc = "Delete an existing marker",
						values = vexpower_panel_getMarker("spec a"),
						set = function(self,key) vexpower_panel_deletemarker(key, "a") vexpower_initialize(true) end,
						get = function() return "" end,
						},
					marker_delete_b = {
						name = "Secondary Spec",
						order=3, type = "select", style = "dropdown",
						desc = "Delete an existing marker",
						values = vexpower_panel_getMarker("spec b"),
						set = function(self,key) vexpower_panel_deletemarker(key, "b") vexpower_initialize(true) end,
						get = function() return "" end,
						},
					marker_deleted_info= {name = vexpower.marker_deleted, type = "description", order=4},
					},
				},
						
			frame_space1 = {name =" ", type = "description", order=21},
			
			grpapp = {
				name = "Appearance",
				order=100, type = "group", dialogInline = true,
				args = {
					grpappsize = {
						name = "Size",
						order=1, type = "group", dialogInline = true,
						args = {
							markerswidth = {
								name = "Width",
								order=1, type = "range",
								desc = "Sets the width of the marker",
								step = 1, min = 1, max = 10,
								set = function(info,val) vexpower_parameters["frame"]["energy"]["markers"]["width"]=val vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["energy"]["markers"]["width"] end,
								},
							},
						},
					space_app1 = {name = " ", type = "description", order=2},
					
					grpappbg = {
						name = "Background",
						order=3, type ="group", dialogInline = true,
						args = {
							bordercolor_likebar = {
								name = "Use the color of the powerbar",
								order=1, type = "toggle", width="full",
								set = function(self,key) vexpower_parameters["frame"]["energy"]["markers"]["color_likebg"]=key vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["energy"]["markers"]["color_likebg"] end,
								},
							markersbg = {
								name = "Color",
								order=2, type = "color", hasAlpha=false,
								desc = "Set the marker's background color",
								disabled = vexpower_parameters["frame"]["energy"]["markers"]["color_likebg"],
								set = function(info,r,g,b,a)
									vexpower_parameters["frame"]["energy"]["markers"]["color"]["r"]=r
									vexpower_parameters["frame"]["energy"]["markers"]["color"]["g"]=g
									vexpower_parameters["frame"]["energy"]["markers"]["color"]["b"]=b
									vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["energy"]["markers"]["color"]["r"],
									vexpower_parameters["frame"]["energy"]["markers"]["color"]["g"],
									vexpower_parameters["frame"]["energy"]["markers"]["color"]["b"] end,
								},
							backgroundopacity = {
								name = "Opacity %",
								order=3, type = "range",
								desc = "Sets the opacity",
								step = 5, min = 0, max = 100,
								set = function(info,val) vexpower_parameters["frame"]["energy"]["markers"]["color"]["a"]=val/100 vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["energy"]["markers"]["color"]["a"]*100 end
								},
							},
						},
					space_app2 = {name =" ", type = "description", order=4},
					
					grpappborder = {
						name = "Border",
						order=5, type ="group", dialogInline = true,
						args = {
							bordercolor_likebar = {
								name = "Use the color of the powerbar",
								order=1, type = "toggle", width="full",
								set = function(self,key) vexpower_parameters["frame"]["energy"]["markers"]["border"]["color_likebg"]=key vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["energy"]["markers"]["border"]["color_likebg"] end,
								},
							markersborder = {
								name = "Color",
								order=2, type = "color", hasAlpha=false,
								desc = "Set the marker's border color",
								disabled = vexpower_parameters["frame"]["energy"]["markers"]["border"]["color_likebg"],
								set = function(info,r,g,b,a)
									vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["r"]=r
									vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["g"]=g
									vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["b"]=b
									vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["r"],
									vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["g"],
									vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["b"] end,
								},
							opacityborder = {
								name = "Opacity %",
								order=3, type = "range",
								desc = "Sets the opacity",
								step = 5, min = 0, max = 100,
								set = function(info,val) vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["a"]=val/100 vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["a"]*100 end
								},
							markersborderwidth = {
								name = "Size",
								order=5, type = "range",
								desc = "Sets the width of the border",
								step = 1, min = 1, max = 10,
								set = function(info,val) vexpower_parameters["frame"]["energy"]["markers"]["border"]["size"]=val vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["energy"]["markers"]["border"]["size"] end,
								},
							},
						},
					},
				},
			}
		}
end

function vexpower_panel_getMarker(val)
	local markers = {}
	if val == "spec a" then
		markers = vexpower_parameters["frame"]["energy"]["markers"]["points_spec_a"]
	elseif val == "spec b" then
		markers = vexpower_parameters["frame"]["energy"]["markers"]["points_spec_b"]
	else
		markers = vexpower_parameters["frame"]["energy"]["markers"]["points"]
	end
	
	local returnvalue = {}
	local timer = 0
	for key,val in pairs(markers) do
		local powertypes = ""
		local powertypeCount = 0
		for k,v in pairs(val) do
			if v then
				local text = ""
				if k == "FOCUS" then
					text = "F"
				elseif k == "MANA" then
					text = "M"
				elseif k == "RUNIC_POWER" then
					text = "RP"
				elseif k == "ENERGY" then
					text = "E"
				elseif k == "RAGE" then
					text = "R"
				end
				if text ~= "" then
					if powertypes ~= "" then
						powertypes = powertypes..", "
					end
					powertypes = powertypes..text
					powertypeCount = powertypeCount + 1
				end
			end
		end
		
		if powertypeCount == 5 then
			powertypes = "all powertypes"
		else
			powertypes = powertypes.." only"
		end
		
		returnvalue[key]=key.." ("..powertypes..")"
		timer = timer + 1
	end
	
	if timer == 0 then
		returnvalue[""] = "No markers created"
	end
	
	return returnvalue
end
	
function vexpower_panel_addmarker()
	local pos = vexpower.new_marker_location
	local spec = vexpower.new_marker_spec
	
	if vexpower_panel_markercheck(pos) then
		local overwrite
		if 		spec == "" 	then
			overwrite = vexpower_parameters["frame"]["energy"]["markers"]["points"][pos] ~= nil
			vexpower_parameters["frame"]["energy"]["markers"]["points"][pos] = vexpower_CopyTable(vexpower.new_marker_powertype)
		elseif 	spec == "a" then
			overwrite = vexpower_parameters["frame"]["energy"]["markers"]["points_spec_a"][pos] ~= nil
			vexpower_parameters["frame"]["energy"]["markers"]["points_spec_a"][pos] = vexpower_CopyTable(vexpower.new_marker_powertype)
		elseif 	spec == "b" then
			overwrite = vexpower_parameters["frame"]["energy"]["markers"]["points_spec_b"][pos] ~= nil
			vexpower_parameters["frame"]["energy"]["markers"]["points_spec_b"][pos] = vexpower_CopyTable(vexpower.new_marker_powertype)
		end
		
		local specname = ""
		if spec == "a" then
			specname = "Primary Spec"
		elseif spec == "b" then
			specname = "Secondary Spec"
		else
			specname = "Both Specs"
		end
		
		if overwrite then
			vexpower.marker_created = "marker (location: "..pos..", visible for: "..specname..") has been overwritten"
		else
			vexpower.marker_created = "marker (location: "..pos..", visible for: "..specname..") successfully created"
		end
	else
		vexpower.marker_created = "ERROR --> "..pos.." <-- is not a valid 'marker' !"
	end
end

function vexpower_panel_markercheck(val)
	local returnvalue = false
	if string.gsub(val, "^%d+%%?", "") == "" then returnvalue = true end
	if val == "" then returnvalue = false end
	return returnvalue
end

function vexpower_panel_deletemarker(pos, spec)
	if spec == "" 		then vexpower_parameters["frame"]["energy"]["markers"]["points"][pos] = nil
	elseif spec == "a" 	then vexpower_parameters["frame"]["energy"]["markers"]["points_spec_a"][pos] = nil
	elseif spec == "b" 	then vexpower_parameters["frame"]["energy"]["markers"]["points_spec_b"][pos] = nil end
	local specname = ""
	if spec == "a" then
		specname = "Primary Spec"
	elseif spec == "b" then
		specname = "Secondary Spec"
	else
		specname = "Both Specs"
	end
	vexpower.marker_deleted = "marker (location: "..pos..", visible for: "..specname..") successfully deleted"
end